﻿var FireShotObserver = {
	observe : function(subject, topic, data)
	{
		if (topic == "openURL")
			FireShotUtils.openPage(data);

		else if (topic == "enableResumeMenu" && document)
		{
			var menu = document.getElementById("mnu-continue-edit");
			var popmenu = document.getElementById("popmnu-continue-edit");
			var toolmenu = document.getElementById("toolmnu-continue-edit");

			if (menu)
				menu.setAttribute("disabled", data != "enable");
			if (popmenu)
				popmenu.setAttribute("disabled", data != "enable");
			if (toolmenu)
				toolmenu.setAttribute("disabled", data != "enable");
		}
		else if (topic == "setupMode" && typeof(myPreferences) != "undefined")
		{
			myPreferences.setBoolPref(prefIsProMode, data == "true");
			FireShotUI.checkAccessibility();
		}
		else if (topic == "setRegistered" && typeof(myPreferences) != "undefined")
		{
			myPreferences.setBoolPref(prefIsRegistered, data == "true");
			FireShotUI.checkAccessibility();
		}
	}
};

var FireShot = {

        canvas  : undefined,
        context : undefined,
        xpcomObject        : undefined,
        flashObjects : new Array(0),
        flashModes : new Array(0),
        editorParams : undefined,
        flashWnd : undefined,
        editorStarted: false,


        initOverlay: function()
        {
                this.initialized = true;
                setTimeout("FireShot.delayedInit();", 200);
        },
		
		deinitOverlay: function()
        {
			FireShot.checkUpdated(false);
			
			var observerService =
					Components.classes["@mozilla.org/observer-service;1"].
						getService(Components.interfaces.nsIObserverService);

			observerService.removeObserver(FireShotObserver, "openURL");
			observerService.removeObserver(FireShotObserver, "enableResumeMenu");
			observerService.removeObserver(FireShotObserver, "setupMode");
			observerService.removeObserver(FireShotObserver, "setRegistered");
        },
		
		checkUpdated: function(fOpenPage)
		{
			var extVersion = FireShotUtils.getBuildVersion();

			var show = myPreferences.getBoolPref(cFirstTimeRun, true);
			if (show)
			{
				myPreferences.setBoolPref(cFirstTimeRun, false);
				if (fOpenPage) 
					FireShotUtils.openPage(cWelcomePageURI + extVersion);
			}
			
			var prevVer = myPreferences.getLocalizedUnicharPref(cCurrentVersion, "0.0");
			if (prevVer != extVersion)
			{
				myPreferences.setUnicharPref(cCurrentVersion, extVersion);
				if (fOpenPage)
					FireShotUtils.openPage(cUpdatedURI + extVersion);
			}	
		},

        delayedInit: function()
        {
				if (!myPreferences.getBoolPref(cToolbarCreated, false))
                {
                        const cToolBarID = "nav-bar";
                        const cTBItemID = "fireshot-Capture-Button";
                        var tbElem = document.getElementById(cToolBarID);
                        var tbItemElem = document.getElementById(cTBItemID);

                        if (tbElem)
                        {
                                if (!tbItemElem)
                                {
                                        tbElem.insertItem(cTBItemID);
                                        tbElem.setAttribute("currentset", tbElem.currentSet);

                                        document.persist(cToolBarID, "currentset");
                                        try {
                                                BrowserToolboxCustomizeDone();
                                    } catch (e) {}

                                        myPreferences.setBoolPref(cToolbarCreated, true)
                                }
                        }
						
                }

				var observerService =
					Components.classes["@mozilla.org/observer-service;1"].
						getService(Components.interfaces.nsIObserverService);

				observerService.addObserver(FireShotObserver, "openURL", false);
				observerService.addObserver(FireShotObserver, "enableResumeMenu", false);
				observerService.addObserver(FireShotObserver, "setupMode", false);
				observerService.addObserver(FireShotObserver, "setRegistered", false);
                
				this.checkUpdated(true);

				FireShotUI.checkAccessibility();
        },

        displayWelcomePage: function(extVersion)
        {
        },

        openPrefs: function()
        {
                window.openDialog("chrome://fireshot/content/fspreferences.xul", "_blank",
                    "chrome,titlebar,toolbar,centerscreen,modal");

				FireShotUI.checkAccessibility();
        },
		
		enterLicense: function()
		{
			if (this.xpcomObject != undefined || this.createXPCOMObject())
                        this.xpcomObject.launchFunction("enterLicense", "", "", "");
		},

        createXPCOMObject: function()
        {
                try 
				{
					netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
					const cid = "@screenshot-program.com/SSSLauncher;1";
					this.xpcomObject = Components.classes[cid].createInstance();
					this.xpcomObject = this.xpcomObject.QueryInterface(Components.interfaces.ISSSLauncher);
					
					var extVersion = FireShotUtils.getBuildVersion();
					this.xpcomObject.launchFunction("setAddonVersion", extVersion, "", "");
                }
                catch (err) {
					alert(err);
					this.xpcomObject = undefined;
					return false;
                }
                
				return true;
        },

        showEditorPrefs: function()
        {
                if (this.xpcomObject != undefined || this.createXPCOMObject())
                        this.xpcomObject.launchFunction("openSettings", "", "", "");
                        //this.xpcomObject.openSettings();
        },

        openFromClipboard: function()
        {
                if (this.xpcomObject != undefined || this.createXPCOMObject())
                        this.xpcomObject.launchFunction("openFromClipboard", "", "", "");
        },

        resumeEditing: function()
        {
                if (this.xpcomObject != undefined)
                {
                        this.xpcomObject.launchFunction("resumeEditing", "", "", "");
                }
        },

        capturePage: function(grabVisible, defAction)
        {
                this.runEditor(grabVisible, defAction, false);
        },

        capturePageDefault: function(grabVisible)
        {
                var areaType = myPreferences.getLocalizedUnicharPref(prefAreaType, "at-visible");
                //setTimeout("FireShot.runEditor(true, FireShot.getDefaultAction());", 1000);
                this.runEditor(areaType == "at-visible", FireShotUI.getDefaultAction(), false);
        },

        waitForClosing: function()
        {
                if (!this.flashWnd.closed)
                        setTimeout("FireShot.waitForClosing();", 500);
                else
                        setTimeout(this.editorParams, 0);
        },

        runEditor: function(grabVisible, defAction, fTimeout)
        {
                if (this.editorStarted) return;

                try
                {
                        if (!fTimeout)
                        {
                                this.flashObjects.length = 0;
                                this.flashModes.length = 0;

                                if (myPreferences.getBoolPref(prefCaptureFlash, true))
                                        FireShotUtils.fixFlash(this.flashObjects, this.flashModes);

                                if (this.flashObjects.length > 0)
                                {
                                        this.editorParams = "FireShot.runEditor(" + grabVisible + ", '" + defAction + "', true);";
                                        this.flashWnd = window.open('chrome://fireshot/content/flashStatus.xul','hi','chrome,centerscreen,alwaysRaised,dependent');
                                        setTimeout("FireShot.waitForClosing();", 0);
                                        return;
                                }
                        }

                        this.editorStarted = true;

                        FireShotUtils.myAlert(1);
                        if (myPreferences.getBoolPref(prefPlaySound, true))
                                FireShotUtils.playSound();

                        if (this.xpcomObject == undefined && !this.createXPCOMObject())
                                return;

                        FireShotUtils.myAlert(3);

                        if (this.canvas == undefined)
                        {
                                this.canvas = document.createElementNS("http://www.w3.org/1999/xhtml", "html:canvas");
                                this.context = this.canvas.getContext("2d");
                        }

                        var topWindow = FireShotUtils.getTopWindow();
                        var root = topWindow.document.documentElement;

                        var canvas_width = 0;
                        var canvas_height = -1;
                        var x = 0;
                        var y = 0;

                        FireShotUtils.myAlert(4);
                        canvas_width = root.clientWidth ? root.clientWidth : topWindow.innerWidth;

                        if (root && root.offsetHeight
                      && root.offsetHeight > topWindow.scrollMaxY
                      && topWindow.innerHeight + topWindow.scrollMaxY <= root.offsetHeight + 40)
                                canvas_height = root.offsetHeight - topWindow.scrollMaxY;

                        FireShotUtils.myAlert(5);
                        if (canvas_height < 0)
                        {
                                FireShotUtils.myAlert(6);
                                canvas_height = topWindow.innerHeight - FireShotUtils.getSBHeight(topWindow);
                        }

                        if (grabVisible)
                        {
                                FireShotUtils.myAlert(7);
                                x =  topWindow.pageXOffset;
                                y =  topWindow.pageYOffset;
                        }
                        else
                        {
                                FireShotUtils.myAlert(8);
                                canvas_width += topWindow.scrollMaxX;
                                canvas_height += topWindow.scrollMaxY;

                                // Дополнительная альтернативная проверка размера полной страницы.
                                // Если срабатывает, то переназначает захватываемое окно.
                                curDoc = document.commandDispatcher.focusedWindow.document;
                                if (curDoc.body)
                                {
                                        var altWidth = curDoc.compatMode == "CSS1Compat" ? curDoc.documentElement.scrollWidth : curDoc.body.scrollWidth;
                                        var altHeight = curDoc.documentElement.scrollHeight;

                                        var frameWidth = curDoc.compatMode == "CSS1Compat" ? curDoc.documentElement.clientWidth : curDoc.body.clientWidth;
                                        var frameHeight = curDoc.compatMode == "CSS1Compat" ? curDoc.documentElement.clientHeight : curDoc.body.clientHeight;

                                        if (altWidth < frameWidth)
                                                altWidth = frameWidth;

                                        if (altHeight < frameHeight)
                                                altHeight = frameHeight;

                                        if (canvas_width < altWidth)
                                        {
                                                canvas_width = altWidth;
                                                topWindow = document.commandDispatcher.focusedWindow;
                                        }

                                        if (canvas_height < altHeight)
                                        {
                                                canvas_height = altHeight;
                                                topWindow = document.commandDispatcher.focusedWindow;
                                        }
                                }
                        }

                        if (canvas_height > 32767)
                        {
                                FireShotUtils.myAlert(9);
                                canvas_height = 32767;
                        }

                        if (canvas_width > 32767)
                        {
                                FireShotUtils.myAlert(10);
                                canvas_width = 32767;
                        }

                        this.canvas.width = canvas_width;
                        this.canvas.height = canvas_height;

                        //alert(canvas.width + 'x' + canvas.height);
                        // Задаём новый размер, если выбрано
                        var resizeAction = myPreferences.getIntPref(prefResizeAction, 0);
                        var newWidth = parseInt(myPreferences.getLocalizedUnicharPref(prefResizeWidth, "800"));
                        var newHeight = parseInt(myPreferences.getLocalizedUnicharPref(prefResizeHeight, "600"));
                        var sizeRatio = parseInt(myPreferences.getLocalizedUnicharPref(prefResizePercentage, "75"));

                        switch (resizeAction)
                        {
                                case 1: newWidth = canvas_width * 0.1; newHeight = canvas_height * 0.1; break;
                                case 2: newWidth = canvas_width * 0.25; newHeight = canvas_height * 0.25; break;
                                case 3: newWidth = canvas_width * 0.5; newHeight = canvas_height * 0.5; break;
                                case 4: newWidth = canvas_width * sizeRatio / 100; newHeight = canvas_height * sizeRatio / 100; break;
                                case 5: newHeight = canvas_height * newWidth / canvas_width; break;
                                case 6: newWidth = canvas_width * newHeight / canvas_height; break;
                                case 7: break;
                                default : newWidth = 0; newHeight = 0;

                        }

                        //alert(newWidth + " " + newHeight);

                        FireShotUtils.myAlert(11);
                        //this.context.scale(0.5, 0.6);
                        this.context.drawWindow(topWindow, x, y, this.canvas.width, this.canvas.height, "rgb(255,255,255)");
						FireShotUtils.myAlert(12);
                        FireShotUtils.restoreFlash(this.flashObjects, this.flashModes);

                        var s = this.canvas.toDataURL("image/png", "");
                    var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                                              .getService(Components.interfaces.nsIIOService);
                    var uriObj = ioService.newURI(s, null, null);
                    var dataChannel = ioService.newChannelFromURI(uriObj);
                    var binStream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                                    .createInstance(Components.interfaces.nsIInputStream);
                        var pictureType = {value: 1};

                        FireShotUtils.myAlert(13);

                        this.xpcomObject.openCapture(dataChannel.open(), topWindow.content.document.location, topWindow.content.document.title, defAction, newWidth, newHeight);

                        this.canvas.width = 0;
                        this.canvas.height = 0;
                }
                catch (err)
                {
                        alert(err);
                }

                this.editorStarted = false;
        },

        upgradeToPro: function()
        {
                if (this.xpcomObject != undefined || this.createXPCOMObject())
                {
                        this.xpcomObject.launchFunction("upgradeToPro", "", "", "");
                }
        },

        integrateIntoIE: function()
        {
                if (this.xpcomObject != undefined || this.createXPCOMObject())
                {
                        this.xpcomObject.launchFunction("integrateIntoIE", FireShotUtils.getBuildVersion(), "", "");
                }
        },

        registerPro: function()
        {
                FireShotUtils.openPage(cRegisterURI);
        },

        openFile: function()
        {
                if (this.xpcomObject != undefined || this.createXPCOMObject())
                        this.xpcomObject.launchFunction("openFile", "", "", "");
        },
		
		testPopup: function(object)
		{
			var popmenu = document.getElementById("test-popup");
			alert(popmenu);
			return;
			
			var nodes = popmenu.childNodes;
			for (var i=0; i < nodes.length; i++) 
			{
				object.appendChild(nodes[i]);
			}
			
			//alert(event);
		},
		
		captureFromSB: function(defAction)
		{
			var grabVisible = !myPreferences.getBoolPref(prefCaptureFullMode, true);
			this.capturePage(grabVisible, defAction);
		},
		
		
};

/*************************************************************************************/

var FireShotUI = 
{

	getDefaultAction: function()
	{
		var action = myPreferences.getLocalizedUnicharPref(prefActionType, "at-edit");
		if (action == "at-upload") return cActionUpload;
		else if (action == "at-save") return cActionSave;
		else if (action == "at-print") return cActionPrint;
		else if (action == "at-copy") return cActionClipboard;
		else if (action == "at-email") return cActionEMail;
		else if (action == "at-paint") return cActionPaint;
		else if (action == "at-from-clipboard") return cActionPaint;
		else return cActionEdit;
	},

	checkAccessibility: function()
	{
        this.setupButtonTooltip();
		this.setupStatusBar();
		this.setupToolsMenu();
		this.setupCtxMenu();
		
		if (!document || !document.getElementById("mnu-fireshot-upgrade")) return;
        var fPro = myPreferences.getBoolPref(prefIsProMode, false);
		var fRegistered = myPreferences.getBoolPref(prefIsRegistered, false);

        document.getElementById("mnu-fireshot-upgrade").hidden = fPro;
        document.getElementById("popmnu-fireshot-upgrade").hidden = fPro;
		document.getElementById("statusbar-fireshot-upgrade").hidden = fPro;
		document.getElementById("toolmnu-fireshot-upgrade").hidden = fPro;
		
        document.getElementById("mnu-fireshot-donate").hidden = fPro;
        document.getElementById("popmnu-fireshot-donate").hidden = fPro;
		document.getElementById("toolmnu-fireshot-donate").hidden = fPro;

        document.getElementById("mnu-fireshot-register").hidden = !fPro || fRegistered;
        document.getElementById("popmnu-fireshot-register").hidden = !fPro || fRegistered;
		document.getElementById("toolmnu-fireshot-register").hidden = !fPro || fRegistered;
		
		document.getElementById("mnu-fireshot-enterlicense").hidden = !fPro || fRegistered;
        document.getElementById("popmnu-fireshot-enterlicense").hidden = !fPro || fRegistered;
		document.getElementById("toolmnu-fireshot-enterlicense").hidden = !fPro || fRegistered;

        document.getElementById("mnu-open-file").setAttribute("disabled", !fPro);
        document.getElementById("popmnu-open-file").setAttribute("disabled", !fPro)
		document.getElementById("toolmnu-open-file").setAttribute("disabled", !fPro)
		
        document.getElementById("mnu-open-clipboard").setAttribute("disabled", !fPro)
        document.getElementById("popmnu-open-clipboard").setAttribute("disabled", !fPro)
		document.getElementById("toolmnu-open-clipboard").setAttribute("disabled", !fPro)
	},
		
	setupStatusBar: function()
	{	
		var fFullCapture = myPreferences.getBoolPref(prefCaptureFullMode, true);
		var modeButton = document.getElementById("statusbar-mode-button");
		
		if (modeButton)
			modeButton.src = "chrome://fireshot/skin/" + (fFullCapture ? "capture_mode_full.png" : "capture_mode_visible.png");
		
		var statusBar = document.getElementById("fs-statusbar");		
		if (statusBar)
			statusBar.hidden = !myPreferences.getBoolPref(prefStatusBar, true);
	},
		
	setupToolsMenu: function()
	{
		var toolsMenu = document.getElementById("fs-toolmnu");		
		if (toolsMenu)
			toolsMenu.hidden = !myPreferences.getBoolPref(prefToolsMenu, true);
	},

	setupCtxMenu: function()
	{
		var hideFlag = !myPreferences.getBoolPref(prefContextMenu, true);
		var ctxSeparator = document.getElementById("context-fireshot-sep")
		if (ctxSeparator)
			ctxSeparator.hidden = hideFlag;
		
		var ctxMenu = document.getElementById("fs-ctxmenu");
		if (ctxMenu)
			ctxMenu.hidden = hideFlag;
	},

	setupButtonTooltip: function()
	{
		var tbItemElem = document.getElementById("fireshot-Capture-Button");
		if (!tbItemElem) return;
		
		tbItemElem.hidden = !myPreferences.getBoolPref(prefNavigationPanel, true);

		var action = this.getDefaultAction();
		var area = myPreferences.getLocalizedUnicharPref(prefAreaType, "at-visible");

		var prefix = area == "at-visible" ? "mnu-visible" : "mnu-entire";

		switch (action)
		{
				case cActionEdit                 : prefix += "-edit"; break;
				case cActionUpload                 : prefix += "-upload"; break;
				case cActionSave                 : prefix += "-save"; break;
				case cActionClipboard         : prefix += "-clipboard"; break;
				case cActionEMail                 : prefix += "-email"; break;
				case cActionPaint                 : prefix += "-paint"; break;

				default: prefix += "-edit";
		}

		var element = document.getElementById(prefix);

		if (element)
				tbItemElem.setAttribute("tooltiptext", element.getAttribute("tooltiptext") + " (Ctrl+Alt+Z)");
	},
	
	toggleCaptureMode: function()
	{
		var fFullCapture = myPreferences.getBoolPref(prefCaptureFullMode, true);
		myPreferences.setBoolPref(prefCaptureFullMode, !fFullCapture);
		this.setupStatusBar();
	},
		
};

window.addEventListener("load", FireShot.initOverlay, false);
window.addEventListener("unload", FireShot.deinitOverlay, false);
//final-ui-startupthis.checkUpdated(true);

