var FireShotUtils = 
{
	fixFlash: function (flashObjects, flashModes)
	{
	        flashObjects.length = 0;
	        flashModes.length = 0;

	        var flashTags = this.getTopWindow().document.getElementsByTagName("embed");
	        for (var i = 0; i < flashTags.length; i++)
	        {
	                var flash = flashTags[i];
	                var attr = flash.getAttribute("wmode");
	                //alert(attr);
	                if (attr == "window" || attr == null || attr == "")
	                {
	                        flashObjects.push(flash);
	                        flashModes.push(attr);
	                }
	        }

	        for (var i = 0; i < flashObjects.length; i ++)
	        {
	                var flash = flashObjects[i];
	                flash.setAttribute("wmode", "opaque");
	                var parent = flash.parentNode;
	                parent.removeChild(flashObjects[i]);
	                parent.appendChild(flash);
	        }
	},

	restoreFlash: function(flashObjects, flashModes)
	{
	        for (var i = 0; i < flashObjects.length; i ++)
	        {
	                var flash = flashObjects[i];
	                flash.setAttribute("wmode", flashModes[i]);
	                var parent = flash.parentNode;
	                parent.removeChild(flashObjects[i]);
	                parent.appendChild(flash);
	        }

	        flashObjects.length = 0;
	        flashModes.length = 0;
	},

	getTopWindow: function()
	{
	        var mediator = Components.classes["@mozilla.org/appshell/window-mediator;1"]
	                         .getService(Components.interfaces.nsIWindowMediator);
	        if (mediator)
	        {
	                var wList = mediator.getZOrderDOMWindowEnumerator("navigator:browser", true);

	                if (wList.hasMoreElements())
	                        return wList.getNext().getBrowser().contentWindow;
	        }
	        else
	                return top.getBrowser().contentWindow;
	},

	getSBHeight: function(window)
	{
	        this.myAlert(101);
	        if (window.scrollMaxX > 0)
	        {
	                this.myAlert(102);
	                var spacer = window.document.createElement("div");
	                this.myAlert(103);
	            spacer.setAttribute("style", "position: fixed; margin: 0px; padding: 0px; border: none; visibility: hidden;  top: 0px; left: 0px; width: 1px; height: 100%; z-index: -1;");
	                this.myAlert(104);
	            window.document.body.appendChild(spacer);
	                this.myAlert(105);

	            var sbHeight = window.innerHeight - spacer.offsetHeight;
	                this.myAlert(106);
	                window.document.body.removeChild(spacer);
	                this.myAlert(107);
	                return sbHeight > 0 && sbHeight < 40 ? sbHeight : 0;
	        }
	        else return 0;
	},

	openPage: function(URI)
	{
	        var tabBrowser = top.getBrowser();
	        if (tabBrowser)
	          tabBrowser.loadOneTab(URI, null, null, null, false, false);
	},

	openLinks: function(linksString)
	{
	        var vLinks = linksString.split("\n");
	        for (i = 0; i < vLinks.length; i ++)
	        {
	          if (vLinks[i] != "")
	                this.openPage(vLinks[i]);
	        }
	},

	myAlert: function(message)
	{
	        return;
	        alert(message);
	},

	playSound: function()
	{
	  try
	  {
	        var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	        var sndURI = ioService.newURI("chrome://fireshot/skin/camera.wav", null, null);
	        var sndPlayer = Components.classes["@mozilla.org/sound;1"].createInstance(Components.interfaces.nsISound);
	        sndPlayer.init();
	        sndPlayer.play(sndURI);
	  } catch (e) {}
	},

	isDefined: function(variable)
	{
	        return (typeof(variable) != "undefined");
	},
	
	getUAExtra: function()
	{
	        var extVersion = this.getBuildVersion();
	        return "FireShot/" + extVersion;
	},

	getBuildVersion: function ()
	{
	        var extVersion = "0.0";
	        try
	        {
	                var extMgr = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
	                if (extMgr)
	                {
	                        var extInfo = extMgr.getItemForID("{0b457cAA-602d-484a-8fe7-c1d894a011ba}");
	                        if (extInfo)
	                                extVersion = extInfo.version == "" ? "0.0" : extInfo.version;
	                }
	        }
	        catch (err) {};

	        return extVersion;
	}
}